/**
 *   File: i_onewiremaster.h
 *
 *   Copyright (C) 2006 by J.M. 
 *   josemanuel.cela@ciemat.es
 */
#ifndef CIEMATCMSI_ONEWIREMASTER_H
#define CIEMATCMSI_ONEWIREMASTER_H

#include "cmsexception.h"

namespace CiematCMS {

/**
 * Interfaz genrica para los dispositivos que actuen como master del
 * bus 1-Wire.
 *
 * @author J.M. <josemanuel.cela@ciemat.es>
 */
class I_OneWireMaster{

  public:
    I_OneWireMaster();
    virtual ~I_OneWireMaster();

    virtual bool singleBit1WRead (void) throw (CMSException)=0;
    virtual void singleBit1WWrite (bool bitValue) throw (CMSException)=0;
    virtual unsigned char read1WByte (void) throw (CMSException)=0;
    virtual void write1WByte (unsigned char byte) throw (CMSException)=0;
    virtual void reset1W (void) throw (CMSException)=0;
};

}

#endif
