/**
 *   File: vmedevice.cpp
 *
 *   Copyright (C) 2007 by J.M.
 *   josemanuel.cela@ciemat.es
 */
#include "vmedevice.h"

namespace CiematCMS {

//**********************************************************
//*********** CONSTRUCTORES Y DESTRUCTORES **************
//**********************************************************
VMEDevice::VMEDevice(I_ConfigTree &configTree, VMEBus &vmeControl,
                     int VMEBaseAddress, int addRelative)
    : I_VMEDevice(configTree, addRelative),
      vmeController(vmeControl)
{
  this->VMEBaseAddress = VMEBaseAddress;

  DEFLOGINFO(NString("Creamos un VMEDevice. Base: ").
      nAppend("%i", getVMEBaseAddress() ));
}

VMEDevice::~VMEDevice() {
  DEFLOGINFO("Destruimos un VMEDevice");
}

int VMEDevice::getVMEBaseAddress(void){
  return VMEBaseAddress;

}

void VMEDevice::setVMEBaseAddress(int add){
  VMEBaseAddress = add;
}

//**********************************************************
//*********** MTODOS PBLICOS **************
//**********************************************************
void VMEDevice::write(string offset, unsigned long valor)
    throw (CMSException)
{
  DEFLOGTRACE(NString("VMEDevice.write: escribimos en address-> ").\
    sAppend(offset).sAppend(" el valor: ").nAppend("%#X", valor));

  // vmeController.WriteLong(convertAddress2LINCO(offset), valor);
  vmeController.WriteWord(
      convertAddress2LINCO(offset) + VMEBaseAddress,
      (unsigned short)valor
                         );
}

void VMEDevice::read(string offset, unsigned long *valor)
    throw (CMSException)
{
  DEFLOGTRACE(NString("VMEDevice.read: leemos del address-> ").\
      sAppend(offset));

  // *valor = vmeController.ReadLong(convertAddress2LINCO(offset));
  *valor = vmeController.ReadWord(
      convertAddress2LINCO(offset) + VMEBaseAddress
                                 );

  DEFLOGTRACE(NString("ROSCard.readVME: byte leido-> ").\
    nAppend("%#X", *valor));
}

}
