/**
 *   File: vmedevice.h
 *
 *   Copyright (C) 2007 by J.M.
 *   josemanuel.cela@ciemat.es
 */
#ifndef CIEMATCMSVMEDEVICE_H
#define CIEMATCMSVMEDEVICE_H

#include "cmsexception.h"
#include "logger.h"
#include "nstring.h"
#include "i_vmedevice.h"
#include <libvme.h>

namespace CiematCMS {

/** Clase provisional que acta de interfaz con la librera LINCO,
 * sustituyendo a la que suministra la librera HAL.
 *
 * El propsito de la misma es no tener que tocar el cdigo ya creado
 * para HAL. Debera bastar con sustituir las llamadas a la clase de HAL
 * por las llamadas a esta.
 *
 * 	@author J.M. <josemanuel.cela@ciemat.es>
 */
class VMEDevice : public I_VMEDevice {

  public:
    VMEDevice(I_ConfigTree &configTree, VMEBus &vmeControl,
              int VMEBaseAddress, int addRelative);
    ~VMEDevice();

    void write(string offset, unsigned long valor)
        throw (CMSException);

    void read(string offset, unsigned long *valor)
        throw (CMSException);

    int getVMEBaseAddress(void);
    void setVMEBaseAddress(int add);

  private:
    VMEBus &vmeController;

    int VMEBaseAddress;
};

}

#endif
