/**
 *   File: vmedevice.cpp
 *
 *   Copyright (C) 2007 by J.M.
 *   josemanuel.cela@ciemat.es
 */
#include "vmedevice.h"

namespace CiematCMS {

//**********************************************************
//*********** CONSTRUCTORES Y DESTRUCTORES **************
//**********************************************************
VMEDevice::VMEDevice(I_ConfigTree &configTree,
                     int VMEBaseAddress, int count,
                     char space, int image, int bus)
    : vmeController(VMEBaseAddress, count, space, image, bus),
      configTree(configTree)
{
  DEFLOGINFO("Creamos un VMEDevice");

  this->VMEBaseAddress= VMEBaseAddress;
}

VMEDevice::~VMEDevice() {
  DEFLOGINFO("Destruimos un VMEDevice");
}

//**********************************************************
//*********** MTODOS PBLICOS **************
//**********************************************************
void VMEDevice::write(string offset, unsigned long valor)
    throw (CMSException)
{
  DEFLOGTRACE(NString("VMEDevice.write: escribimos en address-> ").\
    sAppend(offset).sAppend(" el valor: ").nAppend("%#X", valor));

  // vmeController.WriteLong(convertAddress2LINCO(offset), valor);
  vmeController.WriteWord(convertAddress2LINCO(offset),
                          (unsigned short)valor);
}

void VMEDevice::read(string offset, unsigned long *valor)
    throw (CMSException)
{
  DEFLOGTRACE(NString("VMEDevice.read: leemos del address-> ").\
      sAppend(offset));

  // *valor = vmeController.ReadLong(convertAddress2LINCO(offset));
  *valor = vmeController.ReadWord(convertAddress2LINCO(offset));

  DEFLOGTRACE(NString("ROSCard.readVME: byte leido-> ").\
    nAppend("%#X", *valor));
}

//**********************************************************
//*********** MTODOS GET Y SET **************
//**********************************************************
void VMEDevice::setVMEBaseAddress(int address){
  VMEBaseAddress= address;
}

int VMEDevice::getVMEBaseAddress(void){
  return VMEBaseAddress;
}

//**********************************************************
//*********** MTODOS PRIVADOS **************
//**********************************************************
int VMEDevice::convertAddress2LINCO(string VMEAddressOffset){

  int offset = NString(configTree.getKeyValue(VMEAddressOffset)).\
      convert2Int();

  DEFLOGTRACE(
      NString("VMEDevice::convertAddress2LINCO: convertimos offset: ").
      nAppend("%i", offset).sAppend(" y base: ").
      nAppend("%i", VMEBaseAddress));

  return (VMEBaseAddress + offset);
}

}
