/**
 *   File: cmsexception.cpp
 *
 *   Copyright (C) 2006 by J.M. 
 *   josemanuel.cela@ciemat.es
 */
#include "cmsexception.h"

namespace CiematCMS {

//**********************************************************
//*********** CONSTRUCTORES Y DESTRUCTORES **************
//**********************************************************
CMSException::CMSException(string metodoIn,
    string mensajeIn, int codigoIn) : exception() {

  vaciaLista();
  lista[0].metodo  = metodoIn;
  lista[0].mensaje = mensajeIn;
  lista[0].codigo  = codigoIn;
  ocupacion=1;
}

CMSException::CMSException(string mensajeIn)
  : exception() {
  
  vaciaLista();
  lista[0].metodo  = "";
  lista[0].mensaje = mensajeIn;
  lista[0].codigo  = 0;
  ocupacion=1;
};

CMSException::~CMSException() throw (){
}

//**********************************************************
//*********** MTODOS PBLICOS **************
//**********************************************************
/**
 * Devuelve una cadena estructurada con la informacin
 * almancenada en los mensajes de la excepcion.
 */
string CMSException::getMensaje (void){
  string mensaje = "";
  char numeroTemp[30];

  for (int i=ocupacion-1; i>=0; i--) {
    sprintf (numeroTemp, "%d", lista[i].codigo);
    
    if (lista[i].metodo != "") {
      mensaje+= "En metodo: " + lista[i].metodo + "\n";
      if (lista[i].mensaje != "") 
        mensaje+= "\t" + lista[i].mensaje + "\n";
    }
    else {
      if (lista[i].mensaje != "")
        mensaje+= lista[i].mensaje + "\n";
      else mensaje+= "*** MENSAJE VACIO ***\n";
    }

    if (lista[i].codigo  != 0) {
      mensaje+= "\tCodigo: ";
      mensaje+= numeroTemp;
      mensaje+= "\n";
    }
   
    /*
    mensaje+= lista[i].mensaje + 
        "\n\ten metodo: " + lista[i].metodo +
        "\n\tcon codigo: " + numeroTemp + "\n";
    */
  }
  return mensaje;
}

/**
 * Agrega un mensaje a la cadena de llamadas.
 * Verifica que no se exceda el array de mensajes, incluyendo un
 * mensaje de truncado en el caso afirmativo.
 */
void CMSException::append(string metodoIn, string mensajeIn, int codigoIn)
{
  if (ocupacion < MAX_TAM_ERROR - 1) {
    lista[ocupacion].metodo  = metodoIn;
    lista[ocupacion].mensaje = mensajeIn;
    lista[ocupacion].codigo  = codigoIn;
    ocupacion++;
  }
  else {
    lista[MAX_TAM_ERROR - 1].metodo="";
    lista[MAX_TAM_ERROR - 1].mensaje=EXCESOMENSAJE;
    lista[MAX_TAM_ERROR - 1].codigo=0;
    ocupacion = MAX_TAM_ERROR;
  }
}

void CMSException::append(string metodoIn, string mensajeIn)
{
  if (ocupacion < MAX_TAM_ERROR - 1) {
    lista[ocupacion].metodo  = metodoIn;
    lista[ocupacion].mensaje = mensajeIn;
    ocupacion++;
  }
  else {
    lista[MAX_TAM_ERROR - 1].metodo="";
    lista[MAX_TAM_ERROR - 1].mensaje=EXCESOMENSAJE;
    ocupacion = MAX_TAM_ERROR;
  }
}

void CMSException::append(string metodoIn)
{
  if (ocupacion < MAX_TAM_ERROR - 1) {
    lista[ocupacion].metodo  = metodoIn;
    ocupacion++;
  }
  else {
    lista[MAX_TAM_ERROR - 1].metodo="";
    lista[MAX_TAM_ERROR - 1].mensaje=EXCESOMENSAJE;
    ocupacion = MAX_TAM_ERROR;
  }
}

//**********************************************************
//*********** MTODOS PRIVADOS **************
//**********************************************************
void CMSException::vaciaLista (void){
  for (unsigned int i=0; i< MAX_TAM_ERROR; i++) {
    lista[i].metodo  = "";
    lista[i].mensaje = "";
    lista[i].codigo  = 0;
  }
}

}
