/**
 *   File: configfilesection.cpp
 *
 *   Copyright (C) 2006 by J.M. 
 *   josemanuel.cela@ciemat.es
 */
#include "configfilesection.h"

namespace CiematCMS {

//**********************************************************
//*********** CONSTRUCTORES Y DESTRUCTORES **************
//**********************************************************
ConfigFileSection::ConfigFileSection(string name) {
  sectionName = name;
}

ConfigFileSection::ConfigFileSection() {
  sectionName = "";
}

ConfigFileSection::~ConfigFileSection() {
}

//**********************************************************
//*********** MTODOS PBLICOS **************
//**********************************************************
void ConfigFileSection::addVar(string varName, string value)
  throw (CMSException)
{
  varMap[varName]= value;
}

void ConfigFileSection::delVar(string varName)
    throw (CMSException)
{
  varMap.erase(varName);
}

string ConfigFileSection::getVarValue(string varName)
    throw (CMSException)
{
  map<string, string>::iterator it = varMap.find(varName);

  if (it == varMap.end()) throw( CMSException(
        "ConfigFileSection::getVarValue",
        NString("No se localiza la variable: ").append(varName), 100));
  else return (*it).second;
}


//**********************************************************
//*********** MTODOS GET Y SET **************
//**********************************************************
void ConfigFileSection::setSectionName(string name){
  sectionName = name;
}

string ConfigFileSection::getSectionName(void) {
  return sectionName;
}

unsigned int ConfigFileSection::getTotalVar(void){
  return varMap.size();
}

//**********************************************************
//*********** MTODOS PRIVADOS **************
//**********************************************************

}
