/**
 *   File: dallas_1wireslave.h
 *
 *   Copyright (C) 2006 by J.M. 
 *   josemanuel.cela@ciemat.es
 */
#ifndef CIEMATCMSDALLAS_1WIRESLAVE_H
#define CIEMATCMSDALLAS_1WIRESLAVE_H

#include "i_onewireslave.h"

namespace CiematCMS {

/**
 * @author J.M. <josemanuel.cela@ciemat.es>
 */
class Dallas_1WireSlave : public I_OneWireSlave {

  public:
    Dallas_1WireSlave(I_OneWireMaster &master);
    virtual ~Dallas_1WireSlave();

    void setROMAddress(unsigned long add);
    unsigned long getROMAddress() const;

  protected:
    /* ROM-ADDRESS del integrado (de fbrica). De momento no se emplea.
    Ser til en aquellos casos en los que hay varios esclavos conectados
    al mismo bus y se deban identificar individualmente mediante su
    ROM-ADD.
    Deben construirse mtodos que permitan obtener de forma cmoda las
    direcciones de todos los posibles esclavos conectados a un bus

    Tiene una longitud de 64 bits */
    unsigned long own1WROMAddress;

    virtual void skipRom(void);
    /* La direccin del esclavo es de 64 bits */
    virtual void matchRom(unsigned long slaveAdd) throw (CMSException);

  private:
    /** ROM command codes for (almost) all Dallas Semiconductor 1-Wire
     * devices.
     */
    enum ROM_COMMANDS {
      READ_ROM  =0x33,
      MATCH_ROM =0x55,
      SKIP_ROM  =0xCC,
      SEARCH_ROM=0xF0
    };
};

}

#endif
