/**
 *   File: i_vmemaster.h
 *
 *   Copyright (C) 2006 by J.M. 
 *   josemanuel.cela@ciemat.es
 */
#ifndef CIEMATCMSI_VMEMASTER_H
#define CIEMATCMSI_VMEMASTER_H

#include "cmsexception.h"

namespace CiematCMS {

/**
	@author J.M. <josemanuel.cela@ciemat.es>
*/
class I_VMEMaster{

  public:
    I_VMEMaster();
    virtual ~I_VMEMaster();

    /* En el caso ms general la clase que implemente estos mtodos
    deber convertir el formato de 1 byte que aqu se emplea al
    tamao BYTE, WORD o LONG que se est empleando en la conexin real
    al bus VME.

    El interfaz debe soportar trabajar en los 3 formatos BYTE, WORD o
    LONG, para lo que los metodos writeVME y readVME, debern estar
    sobrecargados para admitir char, int o long.
    De momento slo se implementan los mtodos char que se van a emplear
    */

    /* Se emplean identificadores de direccin en formato STRING,
    propios de HAL en vez de direcciones fsicas en el bus VME */
    virtual void writeVME (string vmeAdd, unsigned char byte)
        throw (CMSException)=0;
    virtual void readVME (string vmeAdd, unsigned char* byte)
        throw (CMSException)=0;

};

}

#endif
