/**
 *   File: vmedevicedummy.h
 *
 *   Copyright (C) 2006 by J.M. 
 *   josemanuel.cela@ciemat.es
 */
#ifndef CIEMATCMSVMEDEVICEDUMMY_H
#define CIEMATCMSVMEDEVICEDUMMY_H

#include "cmsexception.h"
#include "logger.h"
#include "nstring.h"
#include "i_configtree.h"
#include "i_vmedevice.h"

namespace CiematCMS {

/**
	@author J.M. <josemanuel.cela@ciemat.es>
*/
class VMEDeviceDummy : public I_VMEDevice {

  public:
    VMEDeviceDummy(I_ConfigTree &configTree, int VMEBaseAddress,
              int count, char space, int image, int bus);
    ~VMEDeviceDummy();

    void write(string offset, unsigned long valor)
        throw (CMSException);

    void read(string offset, unsigned long *valor)
        throw (CMSException);

    void setVMEBaseAddress(int address);
    int getVMEBaseAddress(void);

  private:
    /* Empotramos un objeto que proporcione la conexin via LINCO */
    //VMEBus vmebus;

    int VMEBaseAddress;

    /* Convierte el "string" que representa el OFFSET del registro
    a un valor numrico que incorpora la direccin base mas el
    propio offset.
    Este mtodo ser empleado por "write" y "read" */
    int convertAddress2LINCO (string VMEAddressOffset);

    //VMEBus vmeController;
    I_ConfigTree &configTree;
};

}

#endif
