/**
 *   File: cmsexception.h
 *
 *   Copyright (C) 2006 by J.M. 
 *   josemanuel.cela@ciemat.es
 */
#ifndef CIEMATCMSCMSEXCEPTION_H
#define CIEMATCMSCMSEXCEPTION_H

#include <exception>
#include <string>
#include <iostream>

#ifndef EXCESOMENSAJE
#define EXCESOMENSAJE "**** LISTA MUY LARGA. MENSAJE TRUNCADO ****"
#endif

using namespace std;       

namespace CiematCMS {

/**
 * Excepcion genrica del proyecto CMS
 * 
 * @author J.M. <josemanuel.cela@ciemat.es>
 */

class CMSException : public exception {

  public:
    CMSException(string metodoIn, string mensajeIn, int codigoIn);
    CMSException(string mensajeIn);
    virtual ~CMSException() throw ();

    string getMensaje (void);
    void append(string metodoIn, string mensajeIn, int codigoIn);
    void append(string metodoIn, string mensajeIn);
    void append(string metodoIn);

  protected:
    struct CLUSTER_ERROR {
      string metodo;
      string mensaje;
      int codigo;
    };

    // Admitimos una lista maxima de traza de error de 300.
    static unsigned int const MAX_TAM_ERROR=300;

  private:
    struct CLUSTER_ERROR lista [MAX_TAM_ERROR];
    // Indica el nmero de elemento ocupados en la "lista".
    unsigned int ocupacion;
    void vaciaLista (void);
};

}

#endif
