/**
 *   File: dallas_1wireslave.h
 *
 *   Copyright (C) 2006 by J.M. 
 *   josemanuel.cela@ciemat.es
 */
#ifndef CIEMATCMSDALLAS_1WIRESLAVE_H
#define CIEMATCMSDALLAS_1WIRESLAVE_H

#include "i_onewireslave.h"

namespace CiematCMS {

/**
 * @author J.M. <josemanuel.cela@ciemat.es>
 */
class Dallas_1WireSlave : public I_OneWireSlave {

  public:
    Dallas_1WireSlave(I_OneWireMaster &master);
    virtual ~Dallas_1WireSlave();

  protected:
    virtual void skipRom (void);
    virtual void matchRom (void) throw (CMSException);

  private:
    /** ROM command codes for (almost) all Dallas Semiconductor 1-Wire
     * devices.
     */
    enum ROM_COMMANDS {
      READ_ROM  =0x33,
      MATCH_ROM =0x55,
      SKIP_ROM  =0xCC,
      SEARCH_ROM=0xF0
    };
};

}

#endif
