/**
 *   File: i_i2cmaster.h
 *
 *   Copyright (C) 2006 by J.M. 
 *   josemanuel.cela@ciemat.es
 */
#ifndef CIEMATCMSI_I2CMASTER_H
#define CIEMATCMSI_I2CMASTER_H

#include "cmsexception.h"

namespace CiematCMS {

/**
	@author J.M. <josemanuel.cela@ciemat.es>
*/
class I_I2CMaster{

  public:
    I_I2CMaster();
    virtual ~I_I2CMaster();

    // Lee del bus I2C tantos bytes como indique "bytesNumber"
    virtual void readI2CBytes(unsigned char* datos,
        unsigned int bytesNumber) throw (CMSException)=0;
    // Escribe en el bus I2C tantos bytes del array "datos" como
    // indique el parmetro "bytesNumber".
    virtual void writeI2CBytes(unsigned char* datos,
        unsigned int bytesNumber) throw (CMSException)=0;

    void setSlaveAdd (unsigned char address);
    unsigned char getSlaveAdd (void);

  protected:
    unsigned char slaveAdd;

};

}

#endif
