/**
 *   File: i_vmemaster.h
 *
 *   Copyright (C) 2006 by J.M. 
 *   josemanuel.cela@ciemat.es
 */
#ifndef CIEMATCMSI_VMEMASTER_H
#define CIEMATCMSI_VMEMASTER_H

#include "cmsexception.h"

namespace CiematCMS {

/**
	@author J.M. <josemanuel.cela@ciemat.es>
*/
class I_VMEMaster{

  public:
    I_VMEMaster();
    virtual ~I_VMEMaster();

    /* En el caso ms general la clase que implemente estos mtodos
    deber convertir el formato de 1 byte que aqu se emplea al
    tamao BYTE, WORD o LONG que se est empleando en la conexin real
    al bus VME */

    /* Esta version de los mtodos no tiene en cuenta la transparencia
    de direcciones que proporciona la librera HAL.

    virtual void writeVME (unsigned long vmeAdd, unsigned char byte)
        throw (CMSException *)=0;
    virtual void readVME (unsigned long vmeAdd, unsigned char* byte)
        throw (CMSException *)=0;

    */

    /* Esta version emplea los identificadores propios de HAL en vez
    de direcciones fsicas en el bus VME */
    virtual void writeVME (string vmeAdd, unsigned char byte)
        throw (CMSException)=0;
    virtual void readVME (string vmeAdd, unsigned char* byte)
        throw (CMSException)=0;

};

}

#endif
