/**
 *   File: pca9516.h
 *
 *   Copyright (C) 2006 by J.M. 
 *   josemanuel.cela@ciemat.es
 */
#ifndef CIEMATCMSPCA9516_H
#define CIEMATCMSPCA9516_H

#include "i_i2cslave.h"
#include "i_i2cmaster.h"

namespace CiematCMS {

/**
 * Bridge I2C. Permite conectar un canal I2C con hasta otros 4,
 * seleccionables individualmente mediante entradas ENABLE.
 *
 * Se implementa por si hace falta aadir alguna lgica adicional
 * pero puede no necesitarse esta representacin del integrado.
 *
 * @author J.M. <josemanuel.cela@ciemat.es>
 */
class PCA9516 : public I_I2CMaster, public I_I2CSlave
{
public:
    PCA9516(I_I2CMaster &master);
    ~PCA9516();

    // Reproduce los mtodos definidos en el interfaz "I_I2CMaster"
    void readI2CBytes(unsigned char* datos, unsigned int bytesNumber)
        throw (CMSException);
    void writeI2CBytes(unsigned char* datos, unsigned int bytesNumber)
        throw (CMSException);
};

}

#endif
