/**
 *   File: $FILENAME$.cpp
 *
 *   Copyright (C) 2006 by J.M. 
 *   josemanuel.cela@ciemat.es
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

using namespace std;

#include <iostream>
#include <cstdlib>
#include "cmsexception.h"
#include "ds2438.h"
#include "ds2482.h"
#include "pca9564.h"
#include "roscard.h"

#include "VMEDevice.hh"
#include "CAENLinuxBusAdapter.hh"
#include "VMEDummyBusAdapter.hh"
#include "VMEAddressTableASCIIReader.hh"
#include "VMEAddressTable.hh"

using namespace HAL;
using namespace CiematCMS;

#define ADDRESSTABLE "ROS25AddressTable.dat"

int main(int argc, char *argv[])
{
/* En esta zona hay que hacer todos los preparativos para el
  acceso a la librera HAL */
  unsigned long BASEADDRESS;
  cout << "==== Configuracion de acceso a sensores ====" << endl;
  cout << "-> Introduzca la direccin base de la ROS: ";
  cin >> hex >> BASEADDRESS;
  cout << endl;


  VMEAddressTableASCIIReader tableReader(ADDRESSTABLE);
  VMEAddressTable addressTable("Address table", tableReader);
  CAENLinuxBusAdapter busAdapter(CAENLinuxBusAdapter::V2718, 0);

  VMEDevice device(addressTable, busAdapter, BASEADDRESS);
  ROSCard ROS(device);
  PCA9564 rosPCA9564(ROS);
  DS2482  rosDS2482(rosPCA9564);
  DS2438  rosDS2438(rosDS2482);
  
  /* A la ROS le indicamos que habilite el acceso a los sensores
  a travs del PCA9516 y que inhabilite el acceso al GOL*/
  ROS.habilitarSensores();
  /* Fijamos el canal del DS2482 que queremos leer */
  rosDS2482.setChannel(DS2482::CH0);
  /* Damos la orden de lectura del sensor y mostramos el resultado */
  float temp=0, volt=0, current=0;
  rosDS2438.getTempVoltCurr(&temp, &volt, &current);

  cout << "-> Resultado de T:" << temp << endl;
  cout << "-> Resultado de V:" << volt << endl;
  cout << "-> Resultado de I:" << current << endl;

// ZONA para pruebecitas.
/*********
  try {
    try {
    cout << "Vamos a lanzar una excepcion" << endl;
    throw (new CMSException ("Metodo main", "Gran cascada", 1000));
    }
    catch (CMSException *b) {
      b->append("Metodo segundo");
      b->append("Metodo tercero");
      b->append("Metodo cuarto", "Mensajito");
      b->append("", "Otro mensajito", 1100);
      throw b;
    }

  }
  catch (CMSException *b) {
    cout << "Hemos petao con: " << endl << endl << b->getMensaje() << endl;
    cout << "Adios bambino" << endl;
  }
*/

  
  return 0;
}
