/**
 *   File: roscard.cpp
 *
 *   Copyright (C) 2006 by J.M. 
 *   josemanuel.cela@ciemat.es
 */
#include "roscard.h"


namespace CiematCMS {

//**********************************************************
//*********** CONSTRUCTORES Y DESTRUCTORES **************
//**********************************************************
ROSCard::ROSCard(VMEDevice &deviceIn)
  : I_VMEMaster(), device(deviceIn){
}

ROSCard::~ROSCard()
{
}

//**********************************************************
//*********** MTODOS PBLICOS **************
//**********************************************************
void ROSCard::writeVME (string vmeAdd, unsigned char byte)
    throw (CMSException)
{
  device.write (vmeAdd, (unsigned long)byte);
}
void ROSCard::readVME (string vmeAdd, unsigned char* byte)
    throw (CMSException)
{
  //uint32_t valor=0;
  //valor= (uint32_t)(*byte);
  //device.read(vmeAdd, &valor);
  uint32_t valor=*byte;
  device.read(vmeAdd, &valor);
}

/** Habilita el acceso a los sensores.
 *
 * Permite acceder a los sensores DS2438 y DS2450 escribiendo en el
 * registro GOL/QPLL un 0 en el bit-0 y un 1 en el bit-1.
 * No modifica el resto de los bits.
 *
 * GOLQPLL ha de estar definido en el AddressTable
 */
void ROSCard::habilitarSensores(void) throw (CMSException){
  unsigned char registro='\0';

  this->readVME("GOLQPLL", &registro);
  // Ponemos a cero el bit-0 y a 1 el bit-1.
  registro= ((registro & 0xFE) | 0x02);
  this->writeVME("GOLQPLL", registro);
}

}


