/**
 *   File: i_i2cslave.h
 *
 *   Copyright (C) 2006 by J.M. 
 *   josemanuel.cela@ciemat.es
 */
#ifndef CIEMATCMSI_I2CSLAVE_H
#define CIEMATCMSI_I2CSLAVE_H

#include "i_i2cmaster.h"

namespace CiematCMS {

/**
 * Interfaz de los dispositivos esclavos que usen el protocolo I2C.
 * @author J.M. <josemanuel.cela@ciemat.es>
 */
class I_I2CSlave{

  public:
    I_I2CSlave(I_I2CMaster &master);
    virtual ~I_I2CSlave();

    void setI2CSlaveAddress (unsigned char add);
    unsigned char getI2CSlaveAddress (void) const;

  protected:
    I_I2CMaster &masterI2C;

    // Direccion I2C propia de esclavo
    unsigned char slaveI2COwnAddress;
};

}

#endif
