/**
 *   File: timegeneral.h
 *
 *   Copyright (C) 2006 by J.M. 
 *   josemanuel.cela@ciemat.es
 */
#ifndef TIMEOPER_H
#define TIMEOPER_H

#include <sys/time.h>
#include <cstdlib>
#include <string>

using namespace std;

/**
 * @author J.M.
 */
namespace CiematCMS {

class TimeGeneral {

  public:
    TimeGeneral();
    ~TimeGeneral();

    /**
     * Devuelve el tiempo transcurrido desde el "initialTime" hasta
     * el momento actual, medido en microsegundos
     */
    long int utimeElapsed(struct timeval* initialTime);
    /** Devuelve la hora actual
     *
     * Almacena la informacin de la hora actual en una estructura
     * tipo "timeval"
     */
    void getActualTime(struct timeval* time);
    /** Devuelve una cadena con la hora actual del sistema.
     *
     * Esta funcin se debera sobrecargar o modificar, para que
     * acepte un parmetro que indique el formato con que se ha de
     * generar la cadena de "hora".
     */
    std::string getActualTime(void);
};

}
#endif
