/**
 *   File: configfilesection.h
 *
 *   Copyright (C) 2006 by J.M. 
 *   josemanuel.cela@ciemat.es
 */
#ifndef CIEMATCMSCONFIGFILESECTION_H
#define CIEMATCMSCONFIGFILESECTION_H

#include <string>
#include <map>
#include "cmsexception.h"
#include "nstring.h"
#include "logger.h"

using namespace std;

namespace CiematCMS {

/**
 * Representa una seccion de un fichero de configuracion
 * 
 * 	@author J.M. <josemanuel.cela@ciemat.es>
 */
class ConfigFileSection{

  public:
    ConfigFileSection(string name);
    ConfigFileSection();
    ~ConfigFileSection();


    void setSectionName (string name);
    string getSectionName (void);

    /* Aade una nueva variable a la seccin. Emite excepcin si
    se excede MAX_VARS */
    void addVar(string varName, string value) throw (CMSException);
    /* Elimina una variable de la seccin */
    void delVar(string varName) throw (CMSException);

    /* Recupera el valor de una variable a partir de su nombre.
    Emite excepcin si no se localiza */
    string getVarValue(string varName) throw (CMSException);

    unsigned int getTotalVar(void);

  private:
    /* Usamos un "template" tipo "map" para el almacenamiento dinmico
    de las variables encontradas. Sera mas propio usar una HASH,
    pero... no hay ganas */
    map<string, string> varMap;

    string sectionName;
};

}

#endif
