/**
 *   File: i_vmedevice.h
 *
 *   Copyright (C) 2006 by J.M. 
 *   josemanuel.cela@ciemat.es
 */
#ifndef CIEMATCMSI_VMEDEVICE_H
#define CIEMATCMSI_VMEDEVICE_H

#include "cmsexception.h"
#include "nstring.h"
#include "logger.h"
#include "i_configtree.h"

namespace CiematCMS {

/**
 * @author J.M. <josemanuel.cela@ciemat.es>
 */
class I_VMEDevice{

  public:
    I_VMEDevice(I_ConfigTree &configTree, int addRelative);
    virtual ~I_VMEDevice();

    virtual void write(string offset, unsigned long valor)
        throw (CMSException)=0;

    virtual void read(string offset, unsigned long *valor)
        throw (CMSException)=0;

    void setVMEAddRelative(int address);
    int getVMEAddRelative(void);

  protected:
    /* Convierte el "string" que representa el OFFSET del registro
    a un valor numrico que incorpora la direccin base mas el
    propio offset.
    Este mtodo ser empleado por "write" y "read" */
    int convertAddress2LINCO (string VMEAddressOffset);

    /* Desplazamiento necesario para alcanzar la direccin base
    de la tarjeta, a partir de la direccin base que se emplee en
    el crate para el objeto "VMEBus" */
    int VMEAddressRelative;

    I_ConfigTree &configTree;
};

}

#endif
