/**
 *   File: nstring.cpp
 *
 *   Copyright (C) 2006 by J.M. 
 *   josemanuel.cela@ciemat.es
 */
#include "nstring.h"
#include <stdio.h>

namespace CiematCMS {

#define MAXCHARSTRLONG 40

NString::NString()
  : string() {
}

NString::NString(string cadena)
  : string(cadena) {
}

NString::~NString(){
}

NString &NString::sAppend(string cadena){
  this->append (cadena);
  return (*this);
}

/* Estos mtodos estn hechos de forma poco ortodoxa. Tal vez convenga
usar algn "template" para definirlos una nica vez, pero ahora tienen
que funcionar */
NString &NString::nAppend(const char *format, char value){
  char cadena [MAXCHARSTRLONG];

  snprintf (cadena, MAXCHARSTRLONG, format, value);
  this->append(cadena);
  return (*this);
}

NString &NString::nAppend(const char *format, int value){
  char cadena [MAXCHARSTRLONG];

  snprintf (cadena, MAXCHARSTRLONG, format, value);
  this->append(cadena);
  return (*this);
}

NString &NString::nAppend(const char *format, long int value){
  char cadena [MAXCHARSTRLONG];

  snprintf (cadena, MAXCHARSTRLONG, format, value);
  this->append(cadena);
  return (*this);
}

NString &NString::nAppend(const char *format, unsigned long value){
  char cadena [MAXCHARSTRLONG];

  snprintf (cadena, MAXCHARSTRLONG, format, value);
  this->append(cadena);
  return (*this);
}

NString &NString::nAppend(const char *format, float value){
  char cadena [MAXCHARSTRLONG];

  snprintf (cadena, MAXCHARSTRLONG, format, value);
  this->append(cadena);
  return (*this);
}

NString &NString::nAppend(const char *format, double value){
  char cadena [MAXCHARSTRLONG];

  snprintf (cadena, MAXCHARSTRLONG, format, value);
  this->append(cadena);
  return (*this);
}

double NString::convert2Double(void){
  double dTemp=0;
  istringstream i(*this);
  if (!(i >> dTemp)) throw CMSException ("NString::convert2Double", 
     NString("No se puede convertir a double: ").append(*this), -100);

  return dTemp;
}

int NString::convert2Int(void){
  int dTemp=0;
  istringstream i(*this);
  if (!(i >> dTemp)) throw CMSException ("NString::convert2Int", 
     NString("No se puede convertir a entero: ").append(*this), -100);

  return dTemp;
}

unsigned long NString::convert2ULong(void){
  unsigned long dTemp=0;
  istringstream i(*this);
  if (!(i >> dTemp)) throw CMSException ("NString::convert2ULong", 
     NString("No se puede convertir a ulong: ").append(*this), -100);

  return dTemp;
}

}
