/**
 *   File: nstring.h
 *
 *   Copyright (C) 2006 by J.M. 
 *   josemanuel.cela@ciemat.es
 */
#ifndef CIEMATCMSNSTRING_H
#define CIEMATCMSNSTRING_H

#include <string>
#include <iostream>
#include <sstream>
#include "cmsexception.h"

using namespace std;

namespace CiematCMS {

/** Sobre-carga de la clase estandar "string"
 *
 * Permite concatenar de forma directa valores numricos con el formato
 * que se desee, siguiendo la misma sintaxis de sprintf.
 *
 * @author J.M. <josemanuel.cela@ciemat.es>
 */
class NString : public string
{
  public:
    NString();
    NString(string cadena);
    ~NString();

    NString &sAppend(string cadena);

    /* Permite concatenar valores siguiendo las especificaciones de
    "sprintf". Devuelven una referencia al propio objeto con el fin
    de poder realizar varias concatenaciones consecutivas */
    NString &nAppend(const char *format, char value);
    NString &nAppend(const char *format, int value);
    NString &nAppend(const char *format, long int value);
    NString &nAppend(const char *format, unsigned long value);
    NString &nAppend(const char *format, float value);
    NString &nAppend(const char *format, double value);

    double convert2Double(void);
    int convert2Int(void);

    unsigned long convert2ULong(void);
};

}

#endif
